#include <CyberLib.h> //Библиотека от Cyber-Place.ru
#include <EEPROM.h>
#include <LiquidCrystal_I2C.h> //закомментировать если дисплей без I2C
LiquidCrystal_I2C lcd(0x3f, 16, 2);  //вместо (0x3f) указываем адрес своего дисплея //закомментировать если дисплей без I2C
#include <LiquidCrystal.h> // раскомментировать если дисплей без I2C
//LiquidCrystal lcd(RW, EN, D4, D5, D6, D7);
//LiquidCrystal lcd(4, 5, 6, 7, 8, 9); // раскомментировать если дисплей без I2C



float e1, p1,d1,e2,p2,d2;
float integra, integra2;
#define i_min 0.0//минимум И составляющей
#define i_max 100.0//максимум И составляющей

uint8_t pwr_TOP;     //максимальная мощность верхнего нагревателя
uint8_t pwr_BOTTOM;  //максимальная мощность нижнего нагревателя

volatile uint8_t tic=0;
volatile uint8_t DimmerUP=220;
volatile uint8_t DimmerDOWN=220;

boolean chet = false;
boolean loadProf = false;

uint8_t curCount = 0;

//current editing step pointer
uint8_t editStep = 0;


 //состояние кнопок по умолчанию
boolean upSwitchState = false;
boolean downSwitchState = false;
boolean cancelSwitchState = false;
boolean okSwitchState = false;

//переменные для кнопок
long ms_button = 0;
boolean  button_state = false;
boolean  button_long_state = false;
boolean  button_state1 = false;
boolean  button_long_state1 = false;

//profile stuff
uint8_t currentProfile = 1;
uint8_t currentStep = 1;
uint8_t profileSteps;

double rampRateStep[9];

uint8_t dwellTimerStep[9];


byte kp1;
byte ki1;
byte kd1;
byte kp2;
byte ki2;
byte kd2;
double startTemp;

uint8_t setpointRamp;
boolean TopStart = false;
boolean flag = false;  //флаг для фиксации стартовой температуры

int temperatureStep[9];

long previousMillis; //это для счетчиков

//double 
volatile uint8_t counter;

//Спецзнак градус цельсия
byte GC[8] = {
  0b01100,
  0b10010,
  0b10010,
  0b01100,
  0b00000,
  0b00000,
  0b00000,
  0b00000
};

byte Th[8] = {
  0b00100,
  0b01110,
  0b11111,
  0b10101,
  0b00000,
  0b10101,
  0b00000,
  0b00000
};

byte Bh[8] = {
  B00000,
  B01001,
  B10010,
  B01001,
  B00000,
  B11111,
  B11111,
  B01110,
};



//these are the different states of the sketch. We call different ones depending on conditions
// ***** TYPE DEFINITIONS *****
typedef enum REFLOW_STATE
{
  REFLOW_STATE_IDLE,
  REFLOW_STATE_MENU_STEPS,
  REFLOW_STATE_MENU_BOTTOM_HEAT,
  REFLOW_STATE_MENU_BOTTOM_PWR,
  REFLOW_STATE_MENU_STEP_RAMP,
  REFLOW_STATE_MENU_STEP_TARGET,
  REFLOW_STATE_MENU_TOP_PWR,
  REFLOW_STATE_MENU_STEP_DWELL,
  REFLOW_STATE_MENU_BOTTOM_P,
  REFLOW_STATE_MENU_BOTTOM_I,
  REFLOW_STATE_MENU_BOTTOM_D,
  REFLOW_STATE_MENU_TOP_P,
  REFLOW_STATE_MENU_TOP_I,
  REFLOW_STATE_MENU_TOP_D,
  REFLOW_STATE_STEP_RAMP,
  REFLOW_STATE_STEP,
  REFLOW_STATE_STEP_DWELL,
  REFLOW_STATE_COMPLETE,
  REFLOW_STATE_ERROR,
  REFLOW_STATE_MENU_RESET
}
reflowState_t;

typedef enum REFLOW_STATUS  //this is simply to check if reflow should be running or not
{
  REFLOW_STATUS_OFF,
  REFLOW_STATUS_ON
}
reflowStatus_t;

#define SENSOR_SAMPLING_TIME 1000 //частота обновления текущей температуры (1000=1раз в секунду)
#define GRAPHICS_SAMPLING_TIME 2000 //скорость движения "звёздочек" при пайке
#define PID_SAMPLING_TIME 50 //скорость пересчета PID
reflowStatus_t reflowStatus;
// Reflow oven controller state machine state variable
reflowState_t reflowState;


//TC read timer variables

unsigned long nextRead1; //переменная для обновления текущей температуры
unsigned long nextRead2; //переменная для движения "звёздочек" при пайке
unsigned long nextRead3; //переменная для обновления PID
//PID stuff

double  Input1, Output1;
int Setpoint1;
//Specify the links and initial tuning parameters


//unsigned long windowStartTime;
//PID stuff
double  Input2, Output2, Setpoint22;
int Setpoint2;
//Specify the links and initial tuning parameters


//Alarm state boolean
boolean alarmOn = false;

//Update whole screen boolean
boolean updateScreen = true;

//назначаем пины уселителя термопары MAX6675 "НИЖНЕГО" нагревателя clk=sck cs=cs do=so
byte thermoCLK2 = 13;  //=sck
byte thermoCS2 = 10;   //=cs
byte thermoDO2 = 12;   //=so
//назначаем пины уселителя термопары MAX6675 "ВЕРХНЕГО" нагревателя   clk=sck cs=cs do=so
byte thermoCLK = 13;  //=sck
byte thermoCS = 11;   //=cs
byte thermoDO = 12;   //=so



// переменные для калмана "ВЕРХНЕГО" нагревателя
float varTerm1 = 0.25;  // среднее отклонение (ищем в excel)
float varProcess1 = 0.0125; // скорость реакции на изменение (подбирается вручную)
float Pc1 = 0.0;
float G1 = 0.0;
float P1 = 1.0;
float Xp1 = 0.0;
float Zp1 = 0.0;
float Xe1 = 0.0;

// переменные для калмана "НИЖНЕГО" нагревателя
float varTerm2 = 0.25;  // среднее отклонение (ищем в excel)
float varProcess2 = 0.0125; // скорость реакции на изменение (подбирается вручную)
float Pc2 = 0.0;
float G2 = 0.0;
float P2 = 1.0;
float Xp2 = 0.0;
float Zp2 = 0.0;
float Xe2 = 0.0;
// переменные для калм
double tc1;
double tc2;


void loadProfile()//this function loads whichever profile currentProfile variable is set to
{
  profileSteps = EEPROM.read((currentProfile - 1) * 29);
  Setpoint2  = EEPROM.read((currentProfile - 1) * 29 + 1);
  Setpoint22 = Setpoint2;
  
  for (uint8_t i = 0; i < 9; i++) {
    rampRateStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 2);
    dwellTimerStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 11);
    temperatureStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 20);
    }
  kp1 = EEPROM.read(480);
  ki1 = EEPROM.read(481);
  kd1 = EEPROM.read(482);
  kp2 = EEPROM.read(483);
  ki2 = EEPROM.read(484);
  kd2 = EEPROM.read(485);
  pwr_TOP = EEPROM.read(486);
  pwr_BOTTOM = EEPROM.read(487);

  return;
}
  
void initEeprom()//Запись в память начальных значений
{
  if (EEPROM.read(500) == 'C')
      {
         // чтото только для уже инициализированой памяти
      }
 else {
// профиль: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
           static byte rom1[]={3,150,4,2,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          5,5,15,1,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,180,190,190,205,210,215,220};

          for (uint8_t j = 0; j < 14; j++) {
            
            for (uint8_t i = 0; i < 29; i++) {
            if (i==22)            {EEPROM.write((29*j)+i, (j*5)+190);}
            else                  {EEPROM.write((29*j)+i, rom1[i]); }
            if ((i==21) && (j>6)) {EEPROM.write((29*j)+i, 220);}
            }
          }

          static byte rom2[]={
// PID верха, Kd умноженое на 100, Ki Rd умноженое на 10
          55,7,30,
// PID низа, Kd умноженое на 100, Ki Rd умноженое на 10
          63,3,30,
// ограниченеи мощности верха и низа в процентах 
          40,85};
          for (int i = 480; i < 488; i++) EEPROM.write(i, rom2[i-480]);
          
// Записываем метку CFG о том что в памяти уже есть значения
          EEPROM.write(500, 'C');
          }
         
         lcd.clear();
         lcd.setCursor(0,0);
         lcd.print("EEPROM"); 
         lcd.setCursor(0,1);
         
         for (uint8_t i=0; i<11; i++) {
          lcd.print(".");
          delay(150);
         }
}

void sReset() {
  asm volatile ("jmp 0");
}


void setup()
{

  pinMode (thermoCLK, OUTPUT);
  pinMode (thermoCLK2, OUTPUT);
  pinMode (thermoCS, OUTPUT);
  pinMode (thermoCS2, OUTPUT);
  pinMode (thermoDO, INPUT);
  pinMode (thermoDO2, INPUT);
  D4_Out; D3_Out; //верхний и нижний выходы нагревателей
  D4_Low; D3_Low; //верхний и нижний выходы установить на выходах низкий уровень сигнала
  D2_In; //настраиваем порт на вход для отслеживания прохождения сигнала через ноль  
  
//CHANGE – прерывание вызывается при любом изменении значения на входе; 
//RISING – вызов прерывания при изменении уровня напряжения с низкого (Low) на высокий(HIGH) 
//FALLING – вызов прерывания при изменении уровня напряжения с высокого (HIGH) на низкий (Low) 
    attachInterrupt(0, detect, FALLING);  // настроить срабатывание прерывания interrupt0 на pin 2 на низкий уровень
    StartTimer1(halfcycle, 50); //время для одного разряда ШИМ 50мкс
    
  
//   Serial.begin(9600); 

  
   //setup pins as input for buttons
  // buzzerPin = 5;
  D5_Out;
  // intefan = 15 (A1); //внутренний вентилятор на D0 выключаем
  D15_Out;
  D15_Low;
  // extefan = 16 (A2); //внешний вентилятор на D1 выключаем
  D16_Out;
  D16_Low;
  D17_Out;
  D17_Low;
  //Назначаем пины кнопок управления
  //upSwitchPin = 6;
  D6_In;
  D6_High; //подтяжка PullUP
  
  //downSwitchPin = 7;
  D7_In;
  D7_High; //подтяжка PullUP
  
  //cancelSwitchPin = 8;
  D8_In;
  D8_High; //подтяжка PullUP
  
  //okSwitchPin = 9;
  D9_In;
  D9_High; //подтяжка PullUP

  //собщение приветствия
  lcd.begin(); // закомментировать если дисплей без I2C
// Для дисплеея спецсимвол Градус целсия ....
  lcd.createChar(0, GC);
  lcd.createChar(1, Th);
  lcd.createChar(2, Bh);
// и его печать
// lcd.write(byte(0));

  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(" ARDUINO REWORK");
  lcd.setCursor(0, 1);
  lcd.print(" v2.0.9 MAX6675");
    
  //Мелодия приветствия
  beep(200,523);
  beep(200,659);
  beep(200,784);
  beep(200,1046); 

  // wait for MAX chips to stabilize and splash screen
  delay(1000);
  initEeprom();
  lcd.clear();

  nextRead1 = millis();

 
  }

int i = 0;

void loop()
{  Start

  //Считываем состояние кнопок управления
  upSwitchState = !D6_Read;
  downSwitchState = !D7_Read;
  cancelSwitchState = !D8_Read;
  okSwitchState = !D9_Read;

  unsigned long currentMillis = millis();
  
  float out_float;  
  int SP1 = Setpoint1;
  int SP2 = Setpoint22;

//бузер при нажатии на кнопки (нервирует), кому надо раскоментируйте ниже 6 строк
//  if (upSwitchState == HIGH || downSwitchState == HIGH || cancelSwitchState == HIGH || okSwitchState == HIGH)
//  {
//    beep(100,1045);
//  }


  if (reflowState == REFLOW_STATE_COMPLETE || alarmOn) {
    if (i < 2 && cancelSwitchState == LOW) {
      alarmOn = true;
      
      for (uint8_t j=1; j<5; j++) {
      beep(100,1046);
      delay(100);
      }
      i++;
    }
    else {
      i = 0;
      alarmOn = false;
    }
  }

  switch (reflowState)
  {
    case REFLOW_STATE_IDLE:
     TopStart = false;
     currentStep = 1;
     counter = 0;
     setpointRamp = 0;

     flag = false;         //после остановки профиля сбрасываем флаг
     DimmerUP=220;
     DimmerDOWN=220;

      //Update whole screen only once
      if (updateScreen) {
        //Настройка экрана в режиме ожидания
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("IDLE ");
        lcd.setCursor(0, 1);
        lcd.print("Pr  ");
        lcd.setCursor(5, 0);
        lcd.write(byte(1));
        lcd.setCursor(5, 1);
        lcd.write(byte(2));
        lcd.write(byte(2));

        updateScreen = false;
      }
      lcd.setCursor(2, 1);
      lcd.print(currentProfile, HEX);

      if (temperatureStep[profileSteps-2]<181) {lcd.print("+");
      lcd.write(byte(2));}
      else {lcd.print("-");
      lcd.write(byte(2));}

      lcd.setCursor(7, 0);
      lcd.print(temperatureStep[profileSteps-1]);
      lcd.write(byte(0));
      lcd.setCursor(7, 1);
      lcd.print(SP2);
      lcd.write(byte(0));
      
      lcdTemp();
      
    
      if (upSwitchState == HIGH && ( millis() - ms_button)>500)//if up switch is pressed go to next profile
      {
        ms_button =  millis();
        currentProfile = currentProfile + 1;
        loadProf= false;
        if (currentProfile >= 14)//if currentProfile = 14 and up is pressed go back to profile 1
        {
          currentProfile = 1;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>500)//same as above just go down one profile
      {
        ms_button =  millis();
        currentProfile = currentProfile - 1;
        loadProf= false;
        if (currentProfile <= 0)
        {
          currentProfile = 14;
        }
      }
      //читаем из eeprom и перенастраиваем ПИД если изменили профиль
      if (!loadProf) {
      loadProfile();
      }
      loadProf= true;
      
//фиксируем момент нажатия кнопки "ОК" + защита от дребезга
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
        button_long_state = false;
      }
//держим "ОК" 5 секунд и заходим в меню настроек      
      if (okSwitchState == HIGH && !button_long_state && ( millis() - ms_button)>5000)
      {
        button_long_state = true;
        button_state = false;
        reflowState = REFLOW_STATE_MENU_STEPS;
        //update next screen
        updateScreen = true;
      }

      //фиксируем момент нажатия кнопки "Cancel" + защита от дребезга
      if (cancelSwitchState == HIGH && !button_state1 && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state1 = true;
        button_long_state1 = false;
        D15_Low; //внутренний вентилятор выключить
        D16_Low; //внешний вентилятор выключить
      }
//держим "Cancel" 8 секунд и стираем память      
      if (cancelSwitchState == HIGH && !button_long_state1 && ( millis() - ms_button)>8000)
      {
        button_long_state1 = true;
        ms_button =  millis();
        button_state1 = false;
        reflowState = REFLOW_STATE_MENU_RESET;
        updateScreen = true;
      }
         if (cancelSwitchState == LOW && button_long_state1) button_long_state1 = false;
//включаем пайку, кнопка сработает после отпускания "ОК" если нажатие меньше 3х секунд       
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        beep(500, 1045);  //звуковой сигнал при старте профиля
        updateScreen = true;
        curCount = 0;
        integra=0;
        integra2=0;
        nextRead2 = millis();
        nextRead3 = millis();
        reflowStatus = REFLOW_STATUS_ON;
        reflowState = REFLOW_STATE_STEP_RAMP;
      }
      break;
//устанавливаем количество шагов профиля
    case REFLOW_STATE_MENU_STEPS:
      if (updateScreen) {
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("Profile ");
        lcd.print(currentProfile);
        lcd.print(" Edit");
        lcd.setCursor(0, 1);
        lcd.print("Profile Steps: ");
        lcd.print(profileSteps);
        updateScreen = false;
      }
      lcd.setCursor(15, 1);
      lcd.print(profileSteps);

      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        profileSteps = profileSteps + 1;
        if (profileSteps >= 10) {
        profileSteps = 9;
       }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        profileSteps = profileSteps - 1;
        if (profileSteps <= 1) 
        {
          profileSteps = 1;
        }
      }
      if (okSwitchState == LOW && button_long_state) button_long_state = false; //чтобы после входа в меню не кнопка "ОК" не считалась нажатой
      
      if (okSwitchState == HIGH && !button_state && !button_long_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_HEAT;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }

      break;

//Стираем всю память и переходим в начало 
      case REFLOW_STATE_MENU_RESET:
         lcd.clear();
         lcd.setCursor(0,0);
         lcd.print("EEPROM formatted");
            for (int i = 0; i < 512; i++){
              EEPROM.write(i, 255);
            }
         sReset();
         //reset();
      break;
//устанавливаем температуру "Нижнего Нагревателя"
    case REFLOW_STATE_MENU_BOTTOM_HEAT:

      if (updateScreen) {
        lcd.setCursor(0, 1);
        lcd.print("Bottom Heat:      ");        
        updateScreen = false;
      }
      lcd.setCursor(12, 1);
      lcd.print(Setpoint2);
      lcd.write(byte(0));
      lcd.print(" ");

      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        Setpoint2 = Setpoint2 + 1;
        if (Setpoint2 >= 200)
        {
          Setpoint2 = 200;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        Setpoint2 = Setpoint2 - 1;
        if (Setpoint2 <= 80)
        {
          Setpoint2 = 80;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_PWR;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
      
 //устанавливаем максимальную мощность "НИЖНЕГО НАГРЕВАТЕЛЯ"     
   case REFLOW_STATE_MENU_BOTTOM_PWR:
      
      if (updateScreen)
      {
        
        lcd.setCursor(0, 1);
        lcd.print("Bottom PWR:     ");        
        updateScreen = false;
      }
      lcd.setCursor(12, 1);      
      lcd.print(pwr_BOTTOM);
      lcd.print("%");
      
      
      
     if (pwr_BOTTOM<=99)
      {      
      lcd.setCursor(15,1);
      lcd.print(" ");
      }
       if (pwr_BOTTOM<=9)
      {      
      lcd.setCursor(14,1);
      lcd.print("  ");
      }
      
       if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        pwr_BOTTOM = pwr_BOTTOM + 1;
        if (pwr_BOTTOM >= 100)
        {
          pwr_BOTTOM = 100;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        pwr_BOTTOM = pwr_BOTTOM - 1;
        if (pwr_BOTTOM <= 0)
        {
         pwr_BOTTOM = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_PWR;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

 //устанавливаем максимальную мощность "ВЕРХНЕГО НАГРЕВАТЕЛЯ"      
       case REFLOW_STATE_MENU_TOP_PWR:
      
      if (updateScreen)
      {
        
        lcd.setCursor(0, 1);
        lcd.print("TOP PWR:     ");        
        updateScreen = false;
      }
      lcd.setCursor(12, 1);      
      lcd.print(pwr_TOP);
      lcd.print("%");
      
      
      
      if (pwr_TOP<=99)
      {      
      lcd.setCursor(15,1);
      lcd.print(" ");
      }
       if (pwr_TOP<=9)
      {      
      lcd.setCursor(14,1);
      lcd.print("  ");
      }
      
       if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        pwr_TOP = pwr_TOP + 1;
        if (pwr_TOP >= 100)
        {
          pwr_TOP = 100;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        pwr_TOP = pwr_TOP - 1;
        if (pwr_TOP <= 0)
        {
         pwr_TOP = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_STEP_RAMP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
      
//устанавливаем скорость нагрева "Верхним Нагревателем"
    case REFLOW_STATE_MENU_STEP_RAMP:

      if (updateScreen) {
        lcd.setCursor(0, 1);
        lcd.print("Step");
        lcd.print(editStep + 1);
        lcd.print(" Ramp:    ");
        updateScreen = false;
      }
      lcd.setCursor(11, 1);
      lcd.print(rampRateStep[editStep] / 4);
      lcd.write(byte(0));
      lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        rampRateStep[editStep] = rampRateStep[editStep] + 1.;
        if (rampRateStep[editStep] >= 12.)  //(только целые числа) максимальная скорость роста температуры делённая на 4
        {
          rampRateStep[editStep] = 12.;  //(только целые числа) максимальная скорость роста температуры делённая на 4
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        rampRateStep[editStep] = rampRateStep[editStep] - 1.;
        if (rampRateStep[editStep] <= 1.)  //(только целые числа) минимальная скорость роста температуры делённая на 4
        {
          rampRateStep[editStep] = 1.;  //(только целые числа) минимальная скорость роста температуры делённая на 4
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {
          editStep = 0;
          reflowState = REFLOW_STATE_MENU_STEP_TARGET;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//устанавливаем температуру "Верхнего Нагревателя"
    case REFLOW_STATE_MENU_STEP_TARGET:
      if (updateScreen) {
        lcd.setCursor(0, 1);
        lcd.print("Step");
        lcd.print(editStep + 1);
        lcd.print(" Target:");
        lcd.print(temperatureStep[editStep]);
        lcd.print("  ");
        updateScreen = false;
      }
      lcd.print(" ");
      lcd.setCursor(13, 1);
      lcd.print(temperatureStep[editStep]);
      lcd.print("   ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        temperatureStep[editStep] = temperatureStep[editStep] + 1;
        if (temperatureStep[editStep] >= 255)
        {
          temperatureStep[editStep] = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        temperatureStep[editStep] = temperatureStep[editStep] - 1;
        if (temperatureStep[editStep] <= 0)
        {
          temperatureStep[editStep] = 0;
        }
        if (temperatureStep[editStep] <= 99)
        {
          lcd.setCursor(13, 1);
          lcd.print("  ");
        }
        if (temperatureStep[editStep] <= 9)
        {
          lcd.setCursor(13, 1);
          lcd.print("   ");
        }
      }

      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {
          editStep = 0;
          reflowState = REFLOW_STATE_MENU_STEP_DWELL;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//устанавливаем время перехода на следующий шаг
    case REFLOW_STATE_MENU_STEP_DWELL:

      if (updateScreen) {
        lcd.setCursor(0, 1);
        lcd.print("Step ");
        lcd.print(editStep + 1);
        lcd.print(" Dwell:");
        lcd.print(dwellTimerStep[editStep]);
        lcd.print("c ");
      }
      lcd.print("  ");
      lcd.setCursor(13, 1);
      lcd.print(dwellTimerStep[editStep]);
      lcd.print("c ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        dwellTimerStep[editStep] = dwellTimerStep[editStep] + 1;
        if (dwellTimerStep[editStep] >= 255)
        {
          dwellTimerStep[editStep] = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        dwellTimerStep[editStep] = dwellTimerStep[editStep] - 1;
        if (dwellTimerStep[editStep] <= 0)
        {
          dwellTimerStep[editStep] = 0;
        }

      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>150)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {

          editStep = 0;
          reflowState = REFLOW_STATE_MENU_BOTTOM_P;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//настройка "ПИД" нижнего нагревателя
    case REFLOW_STATE_MENU_BOTTOM_P:
      if (updateScreen) {
        lcd.setCursor(0, 1);
    //    lcd.print("                  ");
//      lcd.setCursor(3, 2);
        lcd.print("B.Heat: ");
        lcd.setCursor(8, 1);
        lcd.print("P=");
        out_float = kp2/10.0;
        lcd.print(out_float);
        lcd.print("    ");
        updateScreen = false;
      }
      lcd.setCursor(10, 1);
      out_float = kp2/10.0;
      lcd.print(out_float);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kp2 = kp2 + 1;
        if (kp2 >= 255)
        {
          kp2 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kp2 = kp2 - 1;
        if (kp2 <= 0)
        {
          kp2 = 0;
        }

      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_I;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
    case REFLOW_STATE_MENU_BOTTOM_I:
      lcd.setCursor(8, 1);
      lcd.print("I=");
      out_float = ki2/100.0;
      lcd.print(out_float);
      lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        ki2 = ki2 + 1;
        if (ki2 >= 255)
        {
          ki2 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        ki2 = ki2 - 1;
        if (ki2 <= 0)
        {
          ki2 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_BOTTOM_D;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    case REFLOW_STATE_MENU_BOTTOM_D:
      lcd.setCursor(8, 1);
      lcd.print("D=");
      out_float = kd2/100.0;
      lcd.print(out_float);
      lcd.print("      ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kd2 = kd2 + 1;
        if (kd2 >= 255)
        {
          kd2 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kd2 = kd2 - 1;
        if (kd2 <= 0)
        {
          kd2 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>150)
      {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_TOP_P;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//настройка "ПИД" верхнего нагревателя
    case REFLOW_STATE_MENU_TOP_P:
      if (updateScreen) {
        lcd.setCursor(0, 1);
    //    lcd.print("                  ");
    //    lcd.setCursor(5, 2);
        lcd.print("T.Heat: ");
        lcd.setCursor(8, 1);
        lcd.print("P=");
        out_float = kp1/10.0;
        lcd.print(out_float);
        lcd.print("    ");
        updateScreen = false;
      }
      lcd.setCursor(10, 1);
      out_float = kp1/10.0;
      lcd.print(out_float);
      lcd.print("    ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kp1 = kp1 + 1;
        if (kp1 >= 255)
        {
          kp1 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kp1 = kp1 - 1;
        if (kp1 <= 0)
        {
          kp1 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_I;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
    case REFLOW_STATE_MENU_TOP_I:
      lcd.setCursor(8, 1);
      lcd.print("I=");
      out_float = ki1/100.0;
      lcd.print(out_float);
      lcd.print("     ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        ki1 = ki1 + 1;
        if (ki1 >= 255)
        {
          ki1 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        ki1 = ki1 - 1;
        if (ki1 <= 0)
        {
          ki1 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_TOP_D;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    case REFLOW_STATE_MENU_TOP_D:
      lcd.setCursor(8, 1);
      lcd.print("D=");
      out_float = kd1/100.0;
      lcd.print(out_float);
      lcd.print("     ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kd1 = kd1 + 1;
        if (kd1 >= 255)
        {
          kd1 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kd1 = kd1 - 1;
        if (kd1 <= 0)
        {
          kd1 = 0;
        }

      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
//сохраняем текущие параметры в "Память"
        EEPROM.write((currentProfile - 1) * 29, profileSteps);
        EEPROM.write((currentProfile - 1) * 29 + 1, Setpoint2);
        for (uint8_t i = 0; i < 9; i + 1) {
          EEPROM.write(((currentProfile - 1) * 29 + i + 2), rampRateStep[i] );
          EEPROM.write(((currentProfile - 1) * 29 + i + 11), dwellTimerStep[i]);
          EEPROM.write(((currentProfile - 1) * 29 + i + 20), temperatureStep[i]);
          i++;
        }
        EEPROM.write(480, kp1);
        EEPROM.write(481, ki1);
        EEPROM.write(482, kd1);
        EEPROM.write(483, kp2);
        EEPROM.write(484, ki2);
        EEPROM.write(485, kd2);
        
        EEPROM.write(486, pwr_TOP);
        EEPROM.write(487, pwr_BOTTOM);

        
        lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        D15_Low; //внутренний вентилятор выключить
        lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//"процесс пайки", рост температуры с заданной скоростью
    case REFLOW_STATE_STEP_RAMP:
      //currentStep = 1;
      if (updateScreen) {
        lcd.setCursor(0, 0);
        lcd.print(" RUN");
        lcd.setCursor(11, 0);
        lcd.print(" ");
        lcd.setCursor(11, 1);
        lcd.print("*");
        updateScreen = false;
      }
    
    if (TopStart ==true)   
    {
    // если включен верхний нагшреватель рисуем обе звездочки
        lcd.setCursor(11, 1);
        lcd.print("*");
        lcd.setCursor(11, 0);
        lcd.print("*");
    }   
    
//фиксируем стартовую температуру      
        if (!flag) { 
        startTemp = tc1;
        D15_High; //внутренний вентилятор включить 
        //(обдув вентилятором радиаторов симистора или твердотельного реле)
        
        flag = true;}

      lcd.setCursor(4, 0);
      lcd.print(currentStep);
//      lcd.print(" ");
      lcd.setCursor(7, 1);
      lcd.print(SP2);
      lcd.write(byte(0));
      lcd.print("*");
     // ramp rate counter;
      
//счётчик скорости роста температуры                  
      if ((currentMillis - previousMillis) > 4000 / rampRateStep[currentStep - 1])  //seconds counter
       {
        previousMillis = currentMillis;
        counter = counter + 1;
        setpointRamp = counter + startTemp;
        lcd.setCursor(7, 0);
        lcd.print("   ");       
        lcd.setCursor(7, 0);
        lcd.print(setpointRamp);
        lcd.write(byte(0));
        
        if (setpointRamp<100) {
        lcd.print(" ");
        }

        if (Setpoint22 >= setpointRamp)
              { 
              Setpoint2 = setpointRamp;
              }
        else {
              Setpoint1 = setpointRamp;
              }
       }       
//----------------------------------------------------------------------------------------       
     
      if (setpointRamp >= temperatureStep[currentStep - 1]) //если достигли нужной температуры
      {
        TopStart=true; //включаем верх
        lcd.setCursor(7, 0);
        lcd.print(temperatureStep[currentStep - 1]);
        lcd.write(byte(0));
// рисуем звездочку включения верхнего нагревателя - хотя включается по достижению 

        lcd.setCursor(11, 0);
        lcd.print("*");
        flag = false;
        reflowState = REFLOW_STATE_STEP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        D15_Low; //внутренний вентилятор выключить
                
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
        updateScreen = true;
      }
      break;

    case REFLOW_STATE_STEP:
      Setpoint1 = temperatureStep[currentStep - 1];
      if (Input1 >= temperatureStep[currentStep - 1])
      {
        counter = 0;
        reflowState = REFLOW_STATE_STEP_DWELL;        
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        D15_Low; //внутренний вентилятор выключить
        updateScreen = true;
        
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//считаем время перехода на следующий шаг
    case REFLOW_STATE_STEP_DWELL:
    if ((profileSteps == currentStep) && (counter == 0))  //если достигли максимальной температуры профиля на  последнем шаге 
        {
      
      // мелодия окончания пайки
      for (uint8_t j=1; j<5; j++) {
          beep(100,1046);
          delay(100);
          }
        }
      if (currentMillis - previousMillis > 1000) 
      {
        previousMillis = currentMillis;
        counter = counter + 1;
      }
      if (counter == dwellTimerStep[currentStep - 1]) //если счётчик равен установленному времени
      {
        counter = 0;
        setpointRamp = 0;
        if (profileSteps == currentStep) //если достигли последнего шага 
        {
          currentStep = 1;
          flag = false;
          TopStart = false; //после завершения профиля сбрасываем флаг
          reflowState = REFLOW_STATE_COMPLETE;
          D16_High; //внешний вентилятор включить
        }
        else //если шаг не последний
        {          
          currentStep++; //переходим на следующий шаг
          reflowState = REFLOW_STATE_STEP_RAMP;          
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;    
        
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//завершение пайки      
    case REFLOW_STATE_COMPLETE:
      
      reflowStatus = REFLOW_STATUS_OFF;
      reflowState = REFLOW_STATE_IDLE;
      updateScreen = true;
      
      break;
  }
  
//включение нагревателей
  if (reflowStatus == REFLOW_STATUS_ON)
  {
    if (millis() > nextRead2) {
      
      nextRead2 += GRAPHICS_SAMPLING_TIME;
      if (curCount == 0) {
        lcd.setCursor(0, 0);
        lcd.print("*");
        lcd.setCursor(5, 0);
        lcd.write(byte(1));
        curCount = 1;
      }
      else {
        lcd.setCursor(0, 0);
        lcd.print(" ");
        lcd.setCursor(5, 0);
        lcd.print(" ");
        curCount = 0;
      }
     }
      
      lcdTemp();

    if (millis() > nextRead3)
    {
      
      nextRead3 += PID_SAMPLING_TIME;

    if (!TopStart) DimmerUP=220;
    else {
      Output1=Pid1(Input1,Setpoint1,kp1,ki1,kd1);
      DimmerUP=map(Output1,0,200,200,16);
      }
       
    if (!flag) DimmerDOWN=220;
    else {
      Output2=Pid2(Input2,Setpoint2,kp2,ki2,kd2);
      DimmerDOWN=map(Output2,0,200,200,16);
      
    }
    
    }
    
     /*--------------------------------------------------   
    Serial.print(" TOP ");
    Serial.print("  ");
    Serial.print(Input1,0);
    Serial.print("  ");
    Serial.print(Setpoint1,0);
    Serial.print("  ");
    Serial.print(Output1, 0);
    Serial.print("  ");
    Serial.print(DimmerUP);
    Serial.print("  ");
    Serial.print(TopStart,BIN);
    Serial.print("  ");
    Serial.print("Bottom ");
    Serial.print("  ");
    Serial.print(Input2, 0);
    Serial.print("  ");
    Serial.print(Setpoint2,0);
    Serial.print("  ");
    Serial.print(Output2, 0);
    Serial.print("  ");
    Serial.print(DimmerDOWN);
    Serial.print("  ");
    Serial.print(flag,BIN);
    Serial.print("  ");
    Serial.print(tc2-Setpoint22);
    Serial.println("  ");
   ------------------------------------------------------------- */
    
  }
  else
  {
    D3_Low;
    D4_Low;
  }
  End
}

void halfcycle()  //прерывания таймера
{ 
  tic++;  //счетчик  
  if((DimmerUP < tic) && (chet))   D4_High; //управляем выходом
  if((DimmerDOWN < tic) && (!chet)) D3_High;  //управляем выходом
}

void  detect()  // обработка внешнего прерывания.
{
 D4_Low; D3_Low; //логический ноль на выходы 
 RestartTimer1();
 tic=0;       //обнулить счетчик
 chet=!chet; //ЧЕТНОСТЬ ПОЛУВОЛНЫ
} 

  float filter1(float val_1) {  //функция фильтрации показений "Верхней" термопары
  Pc1 = P1 + varProcess1;
  G1 = Pc1/(Pc1 + varTerm1);
  P1 = (1-G1)*Pc1;
  Xp1 = Xe1;
  Zp1 = Xp1;
  Xe1 = G1*(val_1-Zp1)+Xp1; // "фильтрованное" значение
  return(Xe1);
  }

  float filter2(float val_2) {  //функция фильтрации показений "Нижней" термопары
  Pc2 = P2 + varProcess2;
  G2 = Pc2/(Pc2 + varTerm2);
  P2 = (1-G2)*Pc2;
  Xp2 = Xe2;
  Zp2 = Xp2;
  Xe2 = G2*(val_2-Zp2)+Xp2; // "фильтрованное" значение
  return(Xe2);
  }

void lcdTemp()
{ 
      if (millis() > nextRead1)
      {    
        // Read thermocouples next sampling period
        nextRead1 += SENSOR_SAMPLING_TIME;
        //устраняем колебания датчиков температуры                
        Input1 = filter1(max6675_read_temp(thermoCLK,thermoCS,thermoDO));
        Input2 = filter2(max6675_read_temp(thermoCLK2,thermoCS2,thermoDO2));
        tc1 = Input1;
        tc2 = Input2; 

 /* --------------------------------------------------------------------
        // вывод на комп через UART 
        char buf[32];
        sprintf (buf, "OK%03d%03d%03d%03d\r\n", int(Output1/2), int(Output2/2), tc1, tc2); 
        // БУФЕР
        Serial.print(buf); // ВЫВОД
   ------------------------------------------------------------- */      

        lcd.setCursor(12, 0);
        lcd.print("    ");
        lcd.setCursor(12, 0);
        if (isnan(Input1)) {
          lcd.print("Er");
          lcd.print(" ");
        } else {
          lcd.print(tc1);
          lcd.write(byte(0));
          lcd.print(" ");
        }
        lcd.setCursor(12, 1);
        lcd.print("    ");
        lcd.setCursor(12, 1);
        if (isnan(Input2)) {
          lcd.print("Er");
          lcd.print(" ");
        } else {
          lcd.print(tc2);
          lcd.write(byte(0));
          lcd.print(" ");
        }
      }
 
}

double max6675_read_temp (byte ck, byte cs, byte so)              
 { char i; 
    int tmp = 0; 
    
   digitalWrite(cs, LOW);//cs = 0;                            // Stop a conversion in progress 
   asm volatile
    (
     " nop"        "\n\t"
    );
   for (i=15;i>=0;i--)
    {  digitalWrite(ck, HIGH);
      asm volatile
    (
     " nop"        "\n\t"
    );
      if( digitalRead(so))
      tmp|=(1<<i);
    
  
      digitalWrite(ck, LOW);
    asm volatile
    (
     " nop"        "\n\t"
    );
    } 
    
   digitalWrite(cs, HIGH);
   if (tmp & 0x4) {
     return NAN; 
   } else
   return ((tmp>>3))*0.25;
 }

 byte Pid1(double temp, byte ust, byte kP, byte kI, byte kd) 
 {
        byte out = 0;
        static float ed = 0;
        
        
        e1 = (ust - temp); //ошибка регулирования
        p1 =  (kP * e1)/10.0; //П составляющая
        integra = (integra < i_min) ? i_min : (integra > i_max) ? i_max : integra + (kI * e1)/100.0; //И составляющая
        d1 = kd /100.0 * (e1 - ed); //Д составляющая
        ed = e1;
        out = (p1 + integra + d1 < 0) ? 0 : (p1 + integra + d1 > pwr_TOP) ? pwr_TOP : p1 + integra + d1;
        return out;
 }

 byte Pid2(double temp, double ust, byte kP, byte kI, byte kd) 
 {
        byte out = 0;
        static float ed = 0;
        
        e2 = (ust - temp); //ошибка регулирования
        p2 =  (kP * e2)/10.0; //П составляющая
        integra2 = (integra2 < i_min) ? i_min : (integra2 > i_max) ? i_max : integra2 + (kI * e2)/100.0; //И составляющая
        d2 = kd /100.0 * (e2 - ed); //Д составляющая
        ed = e2;
        out = (p2 + integra2 + d2 < 0) ? 0 : (p2 + integra2 + d2 > pwr_BOTTOM) ? pwr_BOTTOM : p2 + integra2 + d2;
        return out;
 }
